setDefaultTab("Main")
local toolsTab = addTab("Main")

local version = "1.0"
UI.Separator()
local botName = "Custom Soule v".. version
local lName = UI.Label(botName)
UI.Separator()

modules.game_textmessage.displayGameMessage("["..botName.."] Custom by: Soule")

local colors = {"red", "orange", "yellow", "green", "blue", "#00008b", "#ee82ee"}
local colorI = 0
macro(100, function()
  colorI = colorI==#colors and 0 or colorI+1
  lName:setColor(colors[colorI])
end)


local version = "4.8"
local currentVersion
local available = false

storage.checkVersion = storage.checkVersion or 0

warning = function() 
    return  
end


UI.Separator()
-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦
-- Safe Rune/Spell Macro by Soule
-- Criado para execução segura de magias e uso de runas
-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦

local storage = storage or {} -- Inicializa o storage caso esteja vazio
local runeID = storage.runeID or 3155 -- Permite edição do ID da runa pelo jogador
local spellText = storage.spellText or "exevo gran mas frigo" -- Spell padrão

-- Ícone com um item fixo, independente do ID da runa escolhida
local i_safeRuneSpell = nil
i_safeRuneSpell = addIcon("safeRuneSpellIcon", {item={id=3155, count=1}, text="Safe Rune/Spell"}, macro(1500, function(m)
  local target = g_game.getAttackingCreature()
  if not target then return end

  if isSafe(8) and getDistanceBetween(pos(), target:getPosition()) <= 4 then
    say(spellText)
  else
    g_game.useWith(Item.create(runeID), target) -- Usa a runa selecionada pelo jogador
  end
end))

-- Ajusta a largura do ícone para melhor exibição
i_safeRuneSpell:setWidth(100)

-- Interface de Configuração
local l_fullSpell = UI.Label("SAFE UE/RUNE")
l_fullSpell:setColor("yellow")
UI.Label("Rune Id")
UI.TextEdit(tostring(runeID), function(widget, text)
  runeID = tonumber(text) or 3155
  storage.runeID = runeID -- Salva a escolha do jogador
end)
UI.Label("Name Spell")
UI.TextEdit(spellText, function(widget, text)
  spellText = text ~= "" and text or "exevo gran mas frigo"
  storage.spellText = spellText
end)

-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦
-- Fim do Safe Rune/Spell Macro by Soule
-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦


-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦
-- Full Spell Macro by Soule
-- Criado para execução automática de magias
-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦

local storage = storage or {} -- Inicializa o storage caso esteja vazio
local fullSpell = storage.fullSpell or "exevo gran mas frigo" -- Magia padrão

-- Ícone com um item fixo para ativação do macro
local i_fullSpell = nil
i_fullSpell = addIcon("fullSpellIcon", {item={id=8078, count=1}, text="Full Spell"}, macro(1500, function(m)
  say(fullSpell) -- Executa a magia automaticamente
end))

-- Ajusta a largura do ícone para melhor exibição
i_fullSpell:setWidth(100)

-- Interface de Configuração
local l_fullSpell = UI.Label("FULL Spell")
l_fullSpell:setColor("yellow") -- Define a cor do texto como vermelho
UI.TextEdit(fullSpell, function(widget, text)
  fullSpell = text ~= "" and text or "exevo gran mas frigo"
  storage.fullSpell = fullSpell
end)

-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦
-- Fim do Full Spell Macro by Soule
-- ¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦¦



UI.Separator()

local BlessConfig = {
    buyAtLogin = true,
    buyCommand = "!bless"
}

BlessConfig.hasBought = false
addIcon("BlessIcon", {item={id=3241, count=1}, text="Bless"}, macro(1000, function(m)
    if BlessConfig.buyAtLogin and not BlessConfig.hasBought then
        say(BlessConfig.buyCommand)
        BlessConfig.hasBought = true
    end
    if g_game.getClientVersion() > 1000 and player:getBlessings() == 0 then
        say(BlessConfig.buyCommand)
    end
end))







-------cavebot icon
-- TOGGLE ICONS FOR CAVEBOT AND TARGETBOT


local cIcon = addIcon("cI",{text="Cave\nBot",switchable=false,moveable=true}, function()
  if CaveBot.isOff() then 
    CaveBot.setOn()
  else 
    CaveBot.setOff()
  end
end)
cIcon:setSize({height=30,width=50})
cIcon.text:setFont('verdana-11px-rounded')

local tIcon = addIcon("tI",{text="Target\nBot",switchable=false,moveable=true}, function()
  if TargetBot.isOff() then 
    TargetBot.setOn()
  else 
    TargetBot.setOff()
  end
end)
tIcon:setSize({height=30,width=50})
tIcon.text:setFont('verdana-11px-rounded')

macro(50,function()
  if CaveBot.isOn() then
    cIcon.text:setColoredText({"CaveBot\n","white","ON","green"})
  else
    cIcon.text:setColoredText({"CaveBot\n","white","OFF","red"})
  end
  if TargetBot.isOn() then
    tIcon.text:setColoredText({"Target\n","white","ON","green"})
  else
    tIcon.text:setColoredText({"Target\n","white","OFF","red"})
  end
end)




--Perfect Widget Status EXP and Balance
--Made By Soule Scripts
--Tested on vBot 4.8 / OTCV8 3.2 rev 4
local ui = setupUI([[
Panel
  width: 350
  height: 500
  x: 200
  y: 100
  phantom: true

  Label
    id: sessionTimeLabel
    x: 50
    y: 110
    font: verdana-11px-rounded

  Label
    id: expPerHourLabel
    x: 50
    y: 125
    font: verdana-11px-rounded
    text-auto-resize: true

  Label
    id: totalExpLabel
    x: 50
    y: 140
    font: verdana-11px-rounded
    text-auto-resize: true

  Label
    id: lastExpGainLabel
    x: 50
    y: 155
    font: verdana-11px-rounded
    text-auto-resize: true

  Label
    id: initialLevelLabel
    x: 50
    y: 170
    font: verdana-11px-rounded

  Label
    id: levelsGainedLabel
    x: 50
    y: 185
    font: verdana-11px-rounded

  Label
    id: levelsPerHourLabel
    x: 50
    y: 200
    font: verdana-11px-rounded

  Label
    id: levelsPerDayLabel
    x: 50
    y: 215
    font: verdana-11px-rounded

  Label
    id: nextLevelLabel
    x: 50
    y: 230
    font: verdana-11px-rounded

  Label
    id: balanceCurrentLabel
    x: 50
    y: 245
    font: verdana-11px-rounded
    text: "Balance Atual: Carregando..."

  Label
    id: balancePerHourLabel
    x: 50
    y: 260
    font: verdana-11px-rounded
    text: "Balance/h: Carregando..."

  Label
    id: balancePerDayLabel
    x: 50
    y: 275
    font: verdana-11px-rounded
    text: "Balance/dia: Carregando..."

  Label
    id: balanceSessionLabel
    x: 50
    y: 290
    font: verdana-11px-rounded
    text: "Balance Sessao: Carregando..."
]], g_ui.getRootWidget())

local storage = storage or {}
local startTime = os.time()
local initialLevel = player:getLevel()
local totalExpGained = 0
local lastExpGain = 0
local currentBalance = 0
local initialBalance = 0 -- Balance inicial

local function formatTime(seconds)
    local hours = math.floor(seconds / 3600)
    local minutes = math.floor((seconds % 3600) / 60)
    local seconds = seconds % 60
    return string.format("%02d:%02d:%02d", hours, minutes, seconds)
end

local function formatNumberAbbreviated(number)
    local suffixes = { "", "k", "M", "B", "T" }
    local suffixIndex = 1

    while number >= 1000 and suffixIndex < #suffixes do
        number = number / 1000
        suffixIndex = suffixIndex + 1
    end

    return string.format("%.2f%s", number, suffixes[suffixIndex])
end

local function calcExpRates()
    local elapsedTime = os.time() - startTime
    if elapsedTime == 0 then
        return 0, "00:00:00"
    end

    local expPerHour = (totalExpGained / elapsedTime) * 3600
    local sessionTime = formatTime(elapsedTime)
    return expPerHour, sessionTime
end

local function calcLevelStats()
    local currentLevel = player:getLevel()
    local levelsGained = currentLevel - initialLevel
    local elapsedTime = os.time() - startTime
    local hoursPlayed = elapsedTime / 3600

    local levelsPerHour = hoursPlayed > 0 and levelsGained / hoursPlayed or 0
    local levelsPerDay = levelsPerHour * 24

    return levelsGained, levelsPerHour, levelsPerDay
end

local function calcNextLevelTime(levelsGained)
    local elapsedTime = os.time() - startTime

    if levelsGained == 0 then
        return elapsedTime -- Retorna o tempo total da sessão se nenhum nível foi ganho
    else
        local timePerLevel = elapsedTime / levelsGained
        return timePerLevel -- Retorna o tempo médio para ganhar um nível
    end
end

local function calcBalanceStats()
    local balanceSession = currentBalance - initialBalance
    local elapsedTime = os.time() - startTime
    local balancePerHour = elapsedTime > 0 and (balanceSession / (elapsedTime / 3600)) or 0
    local balancePerDay = balancePerHour * 24

    return balanceSession, balancePerHour, balancePerDay
end

onTextMessage(function(mode, text)
    if text:find("Your account balance is") then
        local balanceText = text:match("Your account balance is ([%d.]+) gold.")
        if balanceText then
            local sanitizedBalance = balanceText:gsub("%.", "")
            local balance = tonumber(sanitizedBalance)
            if balance then
                if initialBalance == 0 then
                    initialBalance = balance
                end

                currentBalance = balance
                ui.balanceCurrentLabel:setText("Balance Atual: " .. formatNumberAbbreviated(currentBalance))
            end
        end
    elseif text:find("You gained") then
        local expGained = tonumber(text:match("You gained (%d+) experience points"))
        if expGained then
            lastExpGain = expGained
            totalExpGained = totalExpGained + expGained
        end
    end
end)

macro(100, function()
    -- Atualiza as informações do balance no painel
    local balanceSession, balancePerHour, balancePerDay = calcBalanceStats()
    ui.balanceSessionLabel:setText("Balance Sessao: " .. formatNumberAbbreviated(balanceSession))
    ui.balancePerHourLabel:setText("Balance/h: " .. formatNumberAbbreviated(balancePerHour))
    ui.balancePerDayLabel:setText("Balance/dia: " .. formatNumberAbbreviated(balancePerDay))

    -- Atualiza as informações de experiência e nível no painel
    local expPerHour, sessionTime = calcExpRates()
    ui.sessionTimeLabel:setText("Sessao: " .. sessionTime)
    ui.expPerHourLabel:setText("Exp/h: " .. formatNumberAbbreviated(expPerHour))
    ui.totalExpLabel:setText("Exp Sessao: " .. formatNumberAbbreviated(totalExpGained))
    ui.lastExpGainLabel:setText("Exp Mob: " .. formatNumberAbbreviated(lastExpGain))

    local levelsGained, levelsPerHour, levelsPerDay = calcLevelStats()
    ui.initialLevelLabel:setText("Lvl Inicial: " .. initialLevel)
    ui.levelsGainedLabel:setText("Lvl Ganhos: " .. levelsGained)
    ui.levelsPerHourLabel:setText("Level/h: " .. string.format("%.2f", levelsPerHour))
    ui.levelsPerDayLabel:setText("Level/dia: " .. string.format("%.2f", levelsPerDay))

    local nextLevelTime = calcNextLevelTime(levelsGained)
    ui.nextLevelLabel:setText("Prox Lvl: " .. formatTime(nextLevelTime))
end)

macro(300000, function()
    say("!balance") -- Envia o comando para obter o balance
end)


--Made By Soule Scripts
--Tested on vBot 4.8 / OTCV8 3.2 rev 4

