setDefaultTab("Main")
-- allows to test/edit bot lua scripts ingame, you can have multiple scripts like this, just change storage.ingame_lua
UI.Button("Ingame script editor", function(newText)
    UI.MultilineEditorWindow(storage.ingame_hotkeys or "", {title="Hotkeys editor", description="You can add your custom scrupts here"}, function(text)
      storage.ingame_hotkeys = text
      reload()
    end)
  end)
  
  UI.Separator()
  
  for _, scripts in pairs({storage.ingame_hotkeys}) do
    if type(scripts) == "string" and scripts:len() > 3 then
      local status, result = pcall(function()
        assert(load(scripts, "ingame_editor"))()
      end)
      if not status then 
        error("Ingame edior error:\n" .. result)
      end
    end
  end
  
  UI.Separator()

  setDefaultTab("Cave")


addLabel("texto", "SELLWAND")

local sellWand = 9396

if type(storage.ItemsToSell) ~= "table" then
  storage.ItemsToSell = {3366,3414,3420,3364,3360,3554}
end

addSeparator()
addLabel("","Items To Sell")
addSeparator()
local ItemsToSellContainer = UI.Container(function(widget, items)
  storage.ItemsToSell = items
end, true)
addSeparator()
ItemsToSellContainer:setHeight(110)
ItemsToSellContainer:setItems(storage.ItemsToSell)

local getContainerItemsIds = function(data)
  local idsTable = {}
  local data = data or {}
  for _, item in ipairs(data) do
    if type(item) ~= "number" then
      table.insert(idsTable, item.id)
    elseif type(item) == "number" then
      table.insert(idsTable, item)
    end
  end
  return idsTable
end



local sellMacro = macro(200, function()
  local containers = getContainers()
  for i, container in pairs(containers) do
    for j, item in ipairs(container:getItems()) do
      if table.find(getContainerItemsIds(storage.ItemsToSell), item:getId()) then
        useWith(sellWand, item)
        return delay(250)
      end
    end
  end
end)

addIcon("SellIcon", {item={id=sellWand, count=1}, text= "Sell"}, sellMacro)
